// In order to *not* need this ignore, consider extracting the "web" version
// of your plugin as a separate package, instead of inlining it in the same
// package as the core of your plugin.
// ignore: avoid_web_libraries_in_flutter

import 'dart:convert';
import 'dart:ui';

import 'package:amap_flutter_location/amap_location_plugin_platform_interface.dart';
import 'package:flutter/material.dart';
import 'package:flutter_web_plugins/flutter_web_plugins.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:js/js_util.dart';

import 'amap_location_option.dart';
import 'web/amap.dart';
import 'web/loader.dart';

/// A web implementation of the TestWebPluginPlatform of the TestWebPlugin plugin.
class AmapLocationPluginWeb extends AmapLocationPluginPlatform {
  /// Constructs a AmapLocationPluginWeb
  AmapLocationPluginWeb();

  late AMap _aMap;

  static void registerWith(Registrar registrar) {
    AmapLocationPluginPlatform.instance = AmapLocationPluginWeb();
  }

  @override
  void initKey() {}

  @override
  void updatePrivacyShow(bool hasContains, bool hasShow) {}

  @override
  void updatePrivacyAgree(bool hasAgree) {}

  @override
  void setApiKey(String androidKey, String iosKey, String webKey) {
    var promise = load(LoaderOptions(
      key: webKey,
      version: '1.4.15',
      plugins: ['AMap.Geolocation'],
    ));

    promiseToFuture(promise).then((value) {
      print('初始化成功');

      MapOptions _mapOptions = MapOptions(
        zoom: 10,
      );
      _aMap = AMap('container', _mapOptions);
    }, onError: (e) {
      print('初始化错误：$e');
    });
  }

  @override
  Stream<Map<String, Object>> onLocationChanged() {
    return Stream.value({});
  }


  @override
  void setLocationOption(AMapLocationOption locationOption) {

  }

  @override
  void startLocation() {
    _aMap.plugin(['AMap.Geolocation'], allowInterop(() {
      GeolocationOptions _geolocationOptions = GeolocationOptions(
        enableHighAccuracy: false,
        timeout: 10000,
        offset: [10, 20],
        zoomToAccuracy: true,
        position: "RB",
      );
      var geolocation = Geolocation(_geolocationOptions);
      geolocation.getCurrentPosition(allowInterop((status, result) {
        Fluttertoast.showToast(
            msg: "${status}  ${result.message}",
            toastLength: Toast.LENGTH_LONG,
            gravity: ToastGravity.CENTER,
            // timeInSecForIos: 1,
            backgroundColor: const Color(0xB3000000),
            textColor: Colors.white,
            fontSize: 17.0);
        print("=====11111 ${status}  ${result.message}");
      }));
    }));
  }
}
